import YGOProDeck from '..';

const deck = new YGOProDeck();
deck.main.push(123);
deck.main.push(123);
deck.main.push(123);
deck.main.push(456);
deck.main.push(456);
deck.main.push(789);
deck.extra.push(1234);
deck.extra.push(5678);
deck.side.push(12345);

describe('Sample test.', () => {
  it('should encode and decode deck string', () => {
    const encoded = deck.toEncodedString();
    const buf = Buffer.from(
      encoded.replace(/[-_]/g, (m0) => (m0 == '-' ? '+' : '/')),
      'base64',
    );
    expect(buf.length).toBe(24);
    const decoded = new YGOProDeck().fromEncodedString(encoded);
    expect(decoded.main).toStrictEqual(deck.main);
    expect(decoded.extra).toStrictEqual(deck.extra);
    expect(decoded.side).toStrictEqual(deck.side);
  });
  it('should encode and decode ydk text', () => {
    const ydk = deck.toYdkString();
    console.log(ydk);
    expect(ydk.split('\n')).toHaveLength(13);
    const decoded = new YGOProDeck().fromYdkString(ydk);
    expect(decoded.main).toStrictEqual(deck.main);
    expect(decoded.extra).toStrictEqual(deck.extra);
    expect(decoded.side).toStrictEqual(deck.side);
  })
});
